package net.javavideotutorials.assignment3;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

import net.javavideotutorials.assignment3.component.Component;

public class AssemblyLine implements Runnable
{
  private final int MAX_CAPACITY_OF_ASSEMBLY_LINE = 3;
  private Queue<Component> neededPartsQueue = new LinkedList<Component>();
  protected List<Component> componentsBeingBuilt = new ArrayList<Component>();
  private static final AssemblyLine INSTANCE = new AssemblyLine();
  private List<Car> carsBuilt = new ArrayList<Car>();
  public boolean assemblyLineWorking = false;
  
  private AssemblyLine (){}
  
  public static AssemblyLine getInstance()
  {
    return INSTANCE;
  }
  
  public void buildCar()
  {
    Thread thread = new Thread(AssemblyLine.getInstance());
    thread.start();
    assemblyLineWorking = true;
  }
  
  public synchronized void addComponentToBeBuilt(Component component)
  {
    assemblyLineWorking = true;
    if (component == null)
    {
      System.out.println("YOU'RE INSERTING A NULL COMPONENT INTO THE QUEUE!");
    }
    if (componentsBeingBuilt.size() < MAX_CAPACITY_OF_ASSEMBLY_LINE)
    {
      componentsBeingBuilt.add(component);
      component.build();
    }
    else
    {
      neededPartsQueue.add(component);
    }
  }

  public synchronized void notifyComponentDoneAssembly(Component component) 
  {
    System.out.println("Removing " + component.getComponentType());
    componentsBeingBuilt.remove(component);
    System.out.println(componentsBeingBuilt.size() + " Components currently being built.");
    Component nextComponent = neededPartsQueue.poll();
    if (nextComponent != null)
      addComponentToBeBuilt(nextComponent);
    else
    {
      System.out.println("Next component in queue is null, queue size is: " + neededPartsQueue.size());
    }
    if (componentsBeingBuilt.size() == 0 && neededPartsQueue.size() == 0)
    {
      System.out.println("Assembly line has stopped.");
      assemblyLineWorking = false;
    }
  }

  @Override
  public void run() {
    System.out.println("Starting to build car.");
    Car car = new Car();
    car.build();
    while (!car.isBuilt())
    {
      
    }
    carsBuilt.add(car);
    System.out.println("Done building car " + carsBuilt.size() + ".");
    
  }

  public List<Car> getCarsBuilt() {
    return carsBuilt;
  }

  public void setCarsBuilt(List<Car> carsBuilt) {
    this.carsBuilt = carsBuilt;
  }
  
}
