package net.javavideotutorials.assignment3;

import java.util.ArrayList;
import java.util.List;

import net.javavideotutorials.assignment3.component.Component;
import net.javavideotutorials.assignment3.component.Engine;
import net.javavideotutorials.assignment3.component.Frame;
import net.javavideotutorials.assignment3.component.Seat;
import net.javavideotutorials.assignment3.component.Tire;

public class Car 
{
  private Component engine;
  private Component frame;
  private List<Seat> seats = new ArrayList<Seat>(4);
  private List<Tire> tires = new ArrayList<Tire>(4);
  
  public Car ()
  {
    build();
  }
  
  public void build()
  {
    engine = new Engine();
    frame = new Frame();
    seats.add(new Seat());
    seats.add(new Seat());
    seats.add(new Seat());
    seats.add(new Seat());
    seats.add(new Seat());
    tires.add(new Tire());
    tires.add(new Tire());
    tires.add(new Tire());
    tires.add(new Tire());
  }
  
  public Boolean isBuilt()
  {
    boolean doneBuilding = true;
    doneBuilding &= engine.isBuilt();
    doneBuilding &= frame.isBuilt();
    for (Seat seat : seats)
    {
      doneBuilding &= seat.isBuilt();
    }
    for (Tire tire : tires)
    {
      doneBuilding &= tire.isBuilt();
    }
        
    return doneBuilding;
  }
}
