package net.javavideotutorials.assignment3.component;

import net.javavideotutorials.assignment3.AssemblyLine;

public class Frame implements Component, Runnable 
{
  private boolean isBuilt = false;
  AssemblyLine assemblyLine = AssemblyLine.getInstance();
  
  public Frame ()
  {
    assemblyLine.addComponentToBeBuilt(this);
  }
  
  @Override
  public void run() {
    System.out.println("Building " + getComponentType() + " on thread: " + Thread.currentThread().getId());
    try {
      Thread.sleep(5000);
    } catch (InterruptedException e) {
      Thread.interrupted();
    }
    System.out.println("Done Building " + getComponentType() + " on thread: " + Thread.currentThread().getId());
    isBuilt = true;
    assemblyLine.notifyComponentDoneAssembly(this);
  }

  @Override
  public void build() {
    Thread thread = new Thread(this);
    thread.start();
  }

  @Override
  public boolean isBuilt() {
    return isBuilt;
  }

  @Override
  public String getComponentType() {
    return "Frame";
  }

}
