package net.javavideotutorials.assignment3.component;

import net.javavideotutorials.assignment3.AssemblyLine;

public class Seat implements Component, Runnable 
{
  private boolean isBuilt;
  AssemblyLine assemblyLine = AssemblyLine.getInstance();
  
  public Seat ()
  {
    assemblyLine.addComponentToBeBuilt(this);
  }
  
  @Override
  public void run() {
    System.out.println("Building " + getComponentType() + " on thread: " + Thread.currentThread().getId());
    try {
      Thread.sleep(3000);
    } catch (InterruptedException e) {
      e.printStackTrace();
    }
    System.out.println("Done Building " + getComponentType() + " on thread: " + Thread.currentThread().getId());
    isBuilt = true;
    assemblyLine.notifyComponentDoneAssembly(this);
  }

  @Override
  public void build() {
    Thread thread = new Thread(this);
    thread.start();
  }

  @Override
  public boolean isBuilt() {
    return isBuilt;
  }

  @Override
  public String getComponentType() {
    return "Seat";
  }

}
